var bookTag =
{
   id: null,

   init: function()
   {
      bookTag.id = window.arguments[0];
      bookTag.fillList();
   },
   
   fillList: function()
   {
      var epubReader = Components.classes["@mozilla.org/streamconv;1?from=application/epub+zip&to=*/*"]
                       .getService(Components.interfaces.nsISupports).wrappedJSObject;

      var tags = epubReader.getTags();

      if(tags.length == 0)
      {
         var list = document.getElementById("tag_list");
         var message = bookTag.getProperty("book_tag.add_new_tags_hint");
         list.appendItem(message);
      }
      else
      {
         var bookTags = epubReader.getBookTags(bookTag.id);
         var list = document.getElementById("tag_list");
      
         for(var i = 0; i < tags.length; i++)
         {
            var item = list.appendItem(tags[i].name, tags[i].id);
            item.setAttribute("type", "checkbox");

            for(var j = 0; j < bookTags.length; j++)
            {
               if(bookTags[j].id == tags[i].id)
               {
                  item.setAttribute("checked", "true");
               }
            }
         }
      }
   },

   save: function()
   {
      var epubReader = Components.classes["@mozilla.org/streamconv;1?from=application/epub+zip&to=*/*"]
                       .getService(Components.interfaces.nsISupports).wrappedJSObject;

      var list = document.getElementById("tag_list");
      var tags = [];
      
      for(var i = 0; i < list.itemCount; i++)
      {
         var item = list.getItemAtIndex(i);
         
         if(item.checked == true)
         {
            tags.push(item.value);
         }
      }
      
      epubReader.storeBookTags(this.id, tags);

      return true;
   },

   cancel: function()
   {
      return true;
   },
   
   getProperty: function(name)
   {
      var bundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
                   .getService(Components.interfaces.nsIStringBundleService)
                   .createBundle("chrome://epubreader/locale/epubreader.properties");

      var property = bundle.GetStringFromName(name);

      return property;
   }
}