var picker =
{
   save: function(id)
   {
      const Cc = Components.classes;
      const Ci = Components.interfaces;

      var pref = Cc["@mozilla.org/preferences-service;1"]
                 .getService(Ci.nsIPrefService).getBranch("extensions.epubreader.");

      var epubReader = Cc["@mozilla.org/streamconv;1?from=application/epub+zip&to=*/*"]
                       .getService(Ci.nsISupports).wrappedJSObject;

      var filePicker = Cc["@mozilla.org/filepicker;1"].createInstance(Ci.nsIFilePicker);

      var epub = epubReader.getEpub(id);

      try
      {
         var saveDir = pref.getCharPref("dir.save");
      }
      catch(e)
      {
      }

      if(saveDir)
      {
         var dir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
         dir.initWithPath(saveDir);
         filePicker.displayDirectory = dir;
      }

      var title = picker.getProperty("file.save.title");

      filePicker.init(window, title, Ci.nsIFilePicker.modeSave);
      filePicker.defaultExtension = "epub";
      filePicker.defaultString = epub['name'];
      filePicker.appendFilter("epub", "*.epub");

      var ret = filePicker.show();

      if(ret == Ci.nsIFilePicker.returnOK || ret == Ci.nsIFilePicker.returnReplace)
      {
         var source = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
         var root = epubReader.getEpubRoot();

         if(filePicker.file.exists())
         {
            filePicker.file.remove(false);
         }

         source.initWithPath(root);
         source.append(epub['path']);
         source.append(epub['path'] + ".epub");
         source.copyTo(filePicker.file.parent, filePicker.file.leafName);

         pref.setCharPref("dir.save", filePicker.file.parent.path);
      }
   },

   getProperty: function(name)
   {
      var bundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
                   .getService(Components.interfaces.nsIStringBundleService)
                   .createBundle("chrome://epubreader/locale/epubreader.properties");

      var property = bundle.GetStringFromName(name);

      return property;
   }
}